<template>
  <BasicModal
    v-bind="$attrs"
    @cancel="resetFields"
    @register="register"
    :title="title"
    @ok="handleOk"
  >
    <div class="pt-3px pr-3px">
      <BasicForm @register="registerForm" :model="model" />
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, ref } from 'vue';
  import { checkUserApi, saveApi, updateApi, roleLIstApi } from '/@/api/staff/list';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { ListAllCompanyApi } from '/@/api/corporation/list';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useUserStore } from '/@/store/modules/user';
  const { t } = useI18n();
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['ok'],
    setup(_, context) {
      const modelRef = ref({});
      const userStore = useUserStore();
      const { getCheckRole } = userStore;
      const schemas: FormSchema[] = [
        {
          field: 'phone',
          component: 'Input',
          label: '手机号',
          colProps: {
            span: 18,
          },
          // helpMessage: '手机号需在指房宝APP注册后才可新增',
          required: false,
          rules: [
            {
              required: true,
              // @ts-ignore
              validator: async (rule, value) => {
                var reg_tel =
                  /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
                // var reg = /\S+@\S+\.\S+/;
                if (!value) {
                  return Promise.reject(t('common.phone'));
                }
                if (!reg_tel.test(value)) {
                  /* eslint-disable-next-line */
                  return Promise.reject(t('common.phoneError'));
                }
                try {
                  let res = await checkUserApi({ phone: value });
                  console.log('res', res);
                  if (res == true) {
                    return Promise.resolve();
                  } else {
                    return Promise.reject('手机号未在指房宝APP中进行注册');
                  }
                } catch (err) {
                  return Promise.reject(err);
                }
              },
              trigger: 'change',
            },
          ],
        },
        {
          field: 'nickName',
          component: 'Input',
          label: '员工名称',
          colProps: {
            span: 22,
          },
          componentProps: {
            maxLength: 15,
          },
          rules: [
            {
              required: true,
              // @ts-ignore
              validator: async (rule, value) => {
                var reg_tel = /^[a-zA-Z0-9\u4e00-\u9fa5()]+$/;
                // var reg = /\S+@\S+\.\S+/;
                if (!value) {
                  return Promise.reject('请输入员工名称');
                }
                if (!reg_tel.test(value)) {
                  /* eslint-disable-next-line */
                  return Promise.reject('请输入正确的员工名称');
                }
                return Promise.resolve();
              },
              trigger: 'change',
            },
          ],
        },
        {
          field: 'companyId',
          label: '公司',
          component: 'ApiSelect',
          itemProps: {
            validateTrigger: 'blur',
          },
          colProps: {
            span: 22,
          },
          required: true,
          ifShow: getCheckRole('plat_admin'),
          componentProps: {
            api: ListAllCompanyApi,
            showSearch: true,
            resultField: 'list',
            labelField: 'name',
            valueField: 'id',
            immediate: true,
            params: {
              page: 1,
              limit: 1000,
            },
            required: true,
          },
        },
        {
          field: 'roleId',
          component: 'RadioGroup',
          label: '角色',
          required: true,
          itemProps: {
            validateTrigger: 'blur',
          },
          colProps: {
            span: 22,
          },
          defaultValue: 8,
          componentProps: {
            options: [
              {
                label: '公司员工',
                value: 8,
                key: 8,
              },
            ],
          },
        },
        // {
        //   field: 'status',
        //   label: '状态',
        //   component: 'RadioButtonGroup',
        //   required: true,
        //   defaultValue: 1,
        //   itemProps: {
        //     validateTrigger: 'blur',
        //   },
        //   componentProps: {
        //     options: [
        //       { label: '是', value: 1 },
        //       { label: '否', value: 0 },
        //     ],
        //   },
        // },
        {
          field: 'id',
          component: 'Input',
          label: 'id',
          show: false,
        },
      ];
      const title = ref('新 增');
      const { createMessage } = useMessage();
      const [registerForm, { setFieldsValue, validate, updateSchema, resetFields }] = useForm({
        labelWidth: 120,
        schemas,
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });

      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });
      function onDataReceive(data) {
        // 方式1;
        console.log('useModalInner', data);
        setFieldsValue({
          ...data,
          roleId: data.roleId != 2 ? data.roleId : '',
        });
        let setSchema = [
          {
            field: 'roleId',
            component: 'ApiSelect',
            componentProps: {
              disabled: data.id && data.roleId != 2 ? true : false,
              api: roleLIstApi,
              labelField: 'roleName',
              valueField: 'roleId',
            },
          },
          {
            field: 'phone',
            componentProps: {
              disabled: data.id ? true : false,
            },
          },
          {
            field: 'companyId',
            componentProps: {
              disabled: data.id ? (data.roleId != 2 ? true : false) : false,
            },
          },
        ];
        title.value = data.id ? '编辑' : '新增';
        updateSchema(setSchema);
      }

      async function handleOk() {
        let data = await validate();
        const requestApi = data.id ? updateApi : saveApi;
        let res = await requestApi({
          ...data,
          userName: data.phone,
          phone: data.phone,
          nickName: data.nickName,
          roleId: data.roleId,
          id: data.id,
        });
        console.log('res', res);
        context && context.emit('ok', res);
        createMessage.success(t('common.optSuccess'));
        closeModal();
        resetFields();
      }

      return { register, title, schemas, registerForm, model: modelRef, handleOk, resetFields };
    },
  });
</script>
